#include "mex.h"
#include "ANN.h"
#include <fstream>
#include <iostream>
using namespace std;

#define MAX_FILENAME_LENGTH  512

// This is the MEX implementation of the MATLAB function 'annkdtree_load'.
void mexFunction(int nlhs, mxArray *plhs[], int nrhs, const mxArray *prhs[])
{
    // Verify the correctness of the number of input and output parameters as well as their type:
    if(nlhs != 1 || nrhs != 1 || !mxIsChar(prhs[0])) mexErrMsgTxt("Incorrect Sintax\n\ttree = annkdtree_load(treeFileName)\n");

    // Get the name of the file with the kd-tree:
    char treeFileName[MAX_FILENAME_LENGTH];
    mxGetString(prhs[0], treeFileName, MAX_FILENAME_LENGTH);
    
    // Load the kd-tree:
	static ifstream treeFile;
    treeFile.open(treeFileName, ios::in);
    if(!treeFile)
    {
        char errorMsg[128];
        sprintf(errorMsg, "Couldn't open file: %s\n", treeFileName);
        mexErrMsgTxt(errorMsg);
    }
	ANNkd_tree* tree = new ANNkd_tree(treeFile);
    
    treeFile.close();
    
    // Return a pointer to the loaded tree:
    plhs[0] = mxCreateDoubleMatrix(1,1,mxREAL);
    double* pointer_to_tree = mxGetPr(plhs[0]);
    pointer_to_tree[0] = (long) tree;
}
